#ifndef CHIRP_DUAL_ARRAY_H
#define CHIRP_DUAL_ARRAY_H

/* create a new array at the given path, return zero on failure*/
struct chirp_dual_array * chirp_dual_array_create( const char * host, const char *path, int width, int height, int element_size );

/* open an existing array, return zero on failure */
struct chirp_dual_array * chirp_dual_array_open( const char * host, const char *path );

/* return the proprerties of this currently open array */
int chirp_dual_array_width( struct chirp_dual_array *a );
int chirp_dual_array_height( struct chirp_dual_array *a );
int chirp_dual_array_element_size( struct chirp_dual_array *a );

/* get the indicated element and copy it to the pointer data */
int  chirp_dual_array_get( struct chirp_dual_array *a, int i, int j, void *data );

/* set the indicated element by copying it to the pointer data */
int  chirp_dual_array_set( struct chirp_dual_array *a, int i, int j, const void *data );

/* get the indicated row and copy it to the pointer data */
int chirp_dual_array_get_row( struct chirp_dual_array *a, int i, void *data );

/* get the indicated col and copy it to the pointer data */
int chirp_dual_array_get_col( struct chirp_dual_array *a, int i, void *data );

/* set the indicated row by copying it to the pointer data */
int  chirp_dual_array_set_row( struct chirp_dual_array *a, int i, const void *data );

/* set the indicated col by copying it to the pointer data */
int chirp_dual_array_set_col( struct chirp_dual_array *a, int i,const void *data );

/*delete a chirp array*/
int chirp_dual_array_delete( struct chirp_dual_array *a );

/* close this array and free all related resources */
void chirp_dual_array_close( struct chirp_dual_array *a );

#endif
